/*
  mesh-curved-leaf generator
  *
  Jaime Vives Piqueres, ?(C), 1999.
*/

#declare r_leaf=seed(rand(r));
#declare num_sections=15;
#declare cnt_sections=0;
#declare leaf_height=min_height+(max_height-min_height)*rand(r);
#declare sect_height=leaf_height/num_sections;
#declare leaf_radius=medium_radius*.5+medium_radius*rand(r_leaf);
#declare leaf_decr=leaf_radius/num_sections;
#declare act_height=sect_height;
#declare ant_height=0;
#declare act_z=0;
#declare ant_z=0;
#declare curve_rad=leaf_height*.25+leaf_height*rand(r)*.5;
#declare z_decr=sect_height*rand(r);
#declare plain_leaf=
mesh{
 #while (cnt_sections<=num_sections)
  triangle{
   <-leaf_radius,ant_height,ant_z>,
   < leaf_radius,ant_height,ant_z>,
   <-leaf_radius,act_height,act_z>
  }
  triangle{
   < leaf_radius,ant_height,ant_z>,
   < leaf_radius,act_height,act_z>,
   <-leaf_radius,act_height,act_z>
  }
  #declare ant_z=act_z;
  #declare act_z=act_z-z_decr;
  #declare ant_height=act_height;
  #declare act_height=curve_rad*abs(sin(45*cnt_sections/num_sections));
  #declare leaf_radius=leaf_radius-leaf_decr;
  #declare cnt_sections=cnt_sections+1;
 #end
}
// leaf in use
#declare leaf=
object{
 plain_leaf
}

