/*
  Puerta rustica (rustic door)
  *
  See puerta.txt for details
  *
  Jaime Vives Piqueres, ?(C), 1999.
*/

// *** basics ***
#version 3.1;
global_settings{
 ambient_light 0.0
 max_trace_level 8
}

// *** standard ***
#include "colors.inc"
#include "textures.inc"
#include "woods.inc"
#include "stones.inc"
#include "metals.inc"
#include "skies.inc"
#include "macros.inc"

// *** global variables ***
#declare r1=seed(367);

// *** includes for this scene ***
#include "i_ptext.inc"

// *** render control ***
#declare trace_window   =1;
#declare trace_wall     =1;
#declare trace_door     =1;
#declare trace_slab     =1;
#declare trace_milkcan  =0;
#declare trace_vat      =0;
#declare trace_stnandgrs=0;
#declare trace_area     =0;
#declare trace_extelight=1;
#declare trace_moonlight=1;


// *** DOOR ***
#if (trace_door)

// *** wood tables ***
#declare r_w=seed(37);
#declare tablon1=
height_field{
 tga "hf_mad1"
 water_level 0.001
 translate -.5
 rotate 90*y
 rotate -90*x
 scale <22*.975,180*.95,4>
 texture{t_madera rotate 90*x  translate 100*rand(r_w)}
}
#declare tablon2=
height_field{
 tga "hf_mad2"
 water_level 0.001
 translate -.5
 rotate 90*y
 rotate -90*x
 scale <22*.975,180*.95,4>
 texture{t_madera rotate 90*x translate 100*rand(r_w)}
}
#declare tablon3=
height_field{
 tga "hf_mad3"
 water_level 0.001
 translate -.5
 rotate 90*y
 rotate -90*x
 scale <22*.975,180*.95,4>
 texture{t_madera rotate 90*x translate 100*rand(r_w)}
}

// *** knocker ***
#declare knocker=
union{
 sphere{<0,0,0>,2}
 sphere{<0,2,0>,1}
 sphere{<0,3,0>,1}
 sphere{<1,3,0>,.5}
 sphere{<-1,3,0>,.5}
 box{<-2,2,0.5>,<2,4,1>}
 scale 2
 texture{old_metal}
}

// *** key lock ***
#declare key_lock=
difference{
 box{
  <-2,-5,-.1>
  < 2, 5, .1>
 }
 cylinder{<0,2,-.2>,<0,2,.2>,.4}
 cylinder{<0,2,0>,<0,-2,0>,.2}
 texture{old_metal}
}

#declare door_frame=
difference{
 union{
  box{
   <-22*2.59,-186*.5,-3>
   <-22*2.4, 186*.5, 3>
  }
  box{
   <22*1.59,-186*.5,-3>
   <22*1.4, 186*.5, 3>
  }
  box{
   <-22*2.59,186*.48,-3>
   < 22*1.59,186*.50, 3>
  }
 }
 box{
  <-2,-5,-40>
  < 2, 5, 40>
  translate <-11-22-22+1,0,0>
 }
 texture{t_madera_n rotate 90*x translate 100*rand(r_w)}
}

// *** tirador ***
#declare tirador=
box{
 <-2,-5,-.5>
 < 2, 5, .5>
 rotate 45*z
 texture{t_madera}
}

// *** door based on tables ***
#declare puerta=
union{
 object{tablon1}
 object{tablon2 translate -22*x}
 object{tablon3 translate  22*x}
 object{tablon1 rotate 180*z translate  -22*2*x}
 object{knocker translate <-11,110*.5,-3>}
 object{key_lock translate <-11-22-22+2.5,0,-2>}
 object{tirador translate <-11-22-22+10,-7,-3>}
 translate (180*.5)*y
}
object{puerta
 translate -22*x
 rotate 30*y
 translate 22*x
 translate <0,4.5,20>
}
object{door_frame
 translate <0,(180*.5),20>
}

#end // if trace_door


// *** WALL ***
#if (trace_wall)

// *** wall layers ***
#declare wall_paint=
intersection{
 difference{
  height_field{
   tga "hf_wpnt"
   water_level 0.1
   translate -.5
   rotate -90*x
   scale <400,300,.5>
   translate 150*y
  }
  box{
   <-22*2.6,-1,-31>
   < 22*1.6,186,431>
  }
  box{
   <80, 90,-31>
   <160,180,431>
  }
 }
 plane{z,5}
 texture{t_paint}
 translate .1*z
}
#declare wall_bricks=
intersection{
 difference{
  height_field{
   tga "hf_wbrk"
   translate -.5
   rotate -90*x
   scale <400,300,8>
   translate 150*y
  }
  box{
   <-22*2.6,-1,-31>
   < 22*1.6,186,431>
  }
  box{
   <80, 90,-31>
   <160,180,431>
  }
 }
 plane{z,5}
 texture{
  t_brick_map
  translate -.5
  scale <400,300,8>
  translate 150*y
 }
}

// *** build wall ***
#declare whole_wall=
union{
 object{wall_paint}
 object{wall_bricks translate 4*z}
 union{
  object{wall_paint}
  object{wall_bricks translate 4*z}
  rotate -90*y
  translate <-22*2.58,0,199.9>
 }
 union{
  object{wall_paint}
  object{wall_bricks translate 4*z}
  rotate 90*y
  translate <22*1.58,0,199.9>
 }
 box{
  <22*1.6,0,5>
  <22*1.7,260,431>
  texture{t_paint}
 }
}
object{whole_wall}

// *** back wall ***
plane{z,300 texture{t_paint}}

// *** ceil ***
box{
 <-210,250,0>
 < 210,260,600>
 texture{t_slab}
}
box{
 <200,0,0>
 <210,260,600>
 texture{t_slab}
}

// *** FLOOR ***
height_field{
 tga "hf_floor"
 translate -.5
 scale <480,8,360>
 texture{t_floor}
 translate <-28,-2,-360*.5>
}


#end // if trace_wall


// *** WINDOW ***
#if (trace_window)

#include "win01.inc"
object{
 Window_01(80,90,10,t_madera_n,Glass3,Bronze_Metal,0,0,seed(111),0,1)
 translate <120,90+45,15>
}
height_field{
 gif "hf_reja"
 water_level 0.1
 translate -.5
 rotate -90*x
 scale <82,92,2>
 texture{
  //rusted_metal scale 10
  Chrome_Metal normal{crackle scale .1}
 }
 translate <120,90+45,0>
}
#end // if trace_window

// *** courtains ***
#declare cort01=
height_field{
 tga "hf_cort"
 water_level 0.01
 translate -.5
 rotate -90*x
}
object{cort01
 scale <80,90,10>
 texture{
  pigment{
   quilted
   color_map{
    [0.0 White]
    [0.2 White]
    [0.3 Clear]
    [1.0 Clear]
   }
  }
 }
 translate <120,90+45,25>
}



// *** VAT ***
#if (trace_vat)
#include "cubo.inc"
object{cubo
 rotate 14*y
 translate <22*3.2,0,-18>
}
#end


// *** MILK CAN ***
#if (trace_milkcan)

#include "meshlath.inc"
#declare a_lech=array[12]
#declare a_lech[0]=<0,0,0>;
#declare a_lech[1]=<0,0,0>;
#declare a_lech[2]=<3.5,0,0>;
#declare a_lech[3]=<4,.5,0>;
#declare a_lech[4]=<4,8,0>;
#declare a_lech[5]=<3.5,8.5,0>;
#declare a_lech[6]=<2,10,0>;
#declare a_lech[7]=<2,10,0>;
#declare a_lech[8]=<2,12,0>;
#declare a_lech[9]=<2.5,12.5,0>;
#declare a_lech[10]=<0,14,0>;
#declare a_lech[11]=<0,14,0>;
#declare lech=
union{
 object{meshlathe(a_lech,.4,9)}
 difference{
  cylinder{<0,0,-.5>,<0,0,.5>,1}
  cylinder{<0,0,-.6>,<0,0,.6>,.9}
  translate 14.1*y
 }
 difference{
  cylinder{<0,0,-.25>,<0,0,.25>,1}
  cylinder{<0,0,-.26>,<0,0,.26>,.9}
  scale <2,1,1>
  rotate -80*x
  translate <0,7,-4>
 }
 texture{T_Chrome_3B
  normal{bumps .1 scale 2}
 }
}
object{lech
 scale 4
 translate <22*4.5,0,-20>
}

#end


// *** SLAB ***
#if (trace_slab)

#declare slab01=
height_field{
 tga "hf_stn"
 translate -.5
}
object{slab01
 scale <-(22*2.6+22*1.6),8,60>
 texture{t_slab}
 translate <-11,4,28>
}

#end


// *** STOES AND GRASS ***
#if (trace_stnandgrs)
// *** stones ***
#declare r_stone=seed(634);
#declare t_stone=texture{T_Grnt4}
#include "i_stnmcr.inc"
// *** box shape points ***
#declare a_points=array[8]
#declare a_points[0]=<-1,-1,-1>;
#declare a_points[1]=< 1,-1,-1>;
#declare a_points[2]=< 1, 1,-1>;
#declare a_points[3]=<-1, 1,-1>;
#declare a_points[4]=<-1,-1, 1>;
#declare a_points[5]=< 1,-1, 1>;
#declare a_points[6]=< 1, 1, 1>;
#declare a_points[7]=<-1, 1, 1>;
// *** box shape triangles (vector elem. refers to point in a_points[]) ***
#declare a_triang=array[12]
#declare a_triang[0]=<1,3,0>;
#declare a_triang[1]=<1,3,2>;
#declare a_triang[2]=<1,6,5>;
#declare a_triang[3]=<1,6,2>;
#declare a_triang[4]=<5,7,6>;
#declare a_triang[5]=<5,7,4>;
#declare a_triang[6]=<0,7,3>;
#declare a_triang[7]=<0,7,4>;
#declare a_triang[8]=<3,6,7>;
#declare a_triang[9]=<3,6,2>;
#declare a_triang[10]=<0,5,4>;
#declare a_triang[11]=<0,5,1>;
// *** randomize and subdivide the "seed" shape ***
Subdivide_Array(a_points,a_triang,r_stone)
Randomize_Array(a_points,.4,r_stone)
Subdivide_Array(a_points,a_triang,r_stone)
#declare small_stone=Build_Stone(a_points,r_stone)
// *** place stones ***
#declare num_stn=400;
#declare area_v=<300,0,200>;
#declare cnt=1;
union{
#while (cnt<=num_stn)
 object{
  small_stone
  rotate <360*rand(r_stone),360*rand(r_stone),360*rand(r_stone)>
  scale <.25+rand(r_stone),.25+rand(r_stone),.25+rand(r_stone)>
  texture{t_stone}
  translate
   <-area_v.x*.5+area_v.x*rand(r_stone),
    -.1,
    -area_v.z*.5+area_v.z*rand(r_stone)>
 }
 #declare cnt=cnt+1;
#end
}

// *** plants ***
#macro hierbajos(num_leaves,min_height,max_height,medium_radius,base_radius,r)
#local cnt_leaves=1;
union{
#while (cnt_leaves<=num_leaves)
 #include "h_leaf.inc"
 object{leaf
  texture{
   pigment{
    gradient y
    color_map{
     [0 Flesh]
     [.4 OldGold]
     [1 Green]
    }
    scale max_height
   }
   finish{Phong_Dull}
  }
  translate -(base_radius*rand(r))*z
  rotate (-90+180*rand(r))*y
 }
 #declare cnt_leaves=cnt_leaves+1;
#end
}
#end

#declare r=seed(89);
object{ hierbajos(75,15,50,1,5,r) translate -60*x}
object{ hierbajos(75,15,50,1,5,r) translate -70*x}
object{ hierbajos(75,15,50,1,5,r) translate  35*x}
object{ hierbajos(75,15,50,1,5,r) translate  50*x}
object{ hierbajos(75,15,50,1,5,r) translate -110*x}
object{ hierbajos(75,15,50,1,5,r) translate -120*x}

#end // sntandgrs


// *** lights ***
#if (trace_extelight)
#macro bulb(fd)
light_source{
 <0,0,0>
 Gold*.5+Pink*.5+Gray*.5
  #if (trace_area)
    area_light <9,0,0>, <0, 0, 9>, 4, 4
    adaptive 1
    jitter
  #end
 fade_distance fd
 fade_power 4
 looks_like{
  union{
   merge{
    sphere{<0,0,0>,3}
    sphere{<0,3,0>,1.5}
    texture{Glass2}
   }
   union{
    cylinder{<0,3,0>,<0,6,0>,1.3}
    sphere{<0,6,0>,1.5}
    sphere{<0,7,0>,2}
    sphere{<0,8,0>,3}
    texture{old_metal}
   }
   sphere{<0,0,0>,1
    pigment { color rgbf<1, 1, 1, 1> }
    finish { ambient 0 diffuse 0 }
    interior{
     media {
      emission 0.025
      intervals 10
      samples 1, 10
      confidence 0.9999
      variance 1/1000
      density {
        spherical
        turbulence .1
        color_map {
          [0.0 Black]
          [0.99 White]
          [1.0 White*2]
        }
        frequency 1
      }
     }
    }
    no_shadow
    hollow
    scale 10
   }
   rotate 90*x
  }
 }
}
#end
object{bulb(180) translate <-11,200,-10>}
object{bulb(300) translate <150,200,100>}

#end


// *** moonlight ***
#if (trace_moonlight)
light_source{
 <10,0,-750>
 Silver*.125
}
light_source{
 <-10000,30000,-23002>
 Silver*.5
}
#end

// *** camera settings ***
camera{
 location <10,155,-750>
 right 1*x
 direction 3.3*z
 look_at <-1,97,0>
}

sky_sphere{
 S_Cloud4
}
